from math import *
import vtk
import scipy
#import math
from scipy import io


#--------------------------------------------------------------------------------------
# Load Data
#--------------------------------------------------------------------------------------
# DATA1
#--------------------------------------------------------------------------------------
# Pos data
filename ="Data1_Points.bin"    
f = open(filename, 'rb')
Npos1 = io.fread(f,1,'d')
print Npos1
CenterPos1 = io.fread(f,3,'d');
print CenterPos1

dPos1 = vtk.vtkDoubleArray()
dPos1.SetNumberOfComponents(3)
dPos1.SetNumberOfTuples(Npos1)
for i in range(Npos1):
    data = io.fread(f,3,'d')
    if i == 0:
        print data   
    dPos1.SetTuple3(i,data[0]*1000,data[1]*1000,data[2]*1000)
f.close

# Pressure Data
filename = "Data1_Scalars.bin"
f = open(filename,'rb')
dP1 = vtk.vtkDoubleArray()
dP1.SetNumberOfComponents(1)
dP1.SetNumberOfTuples(Npos1)
dP1.SetName('Pressure')

for i in range(Npos1):
    data = io.fread(f,1,'d')
    dP1.SetTuple1(i,data)
         
f.close

# Point
point1 = vtk.vtkPoints()
point1.SetNumberOfPoints(Npos1)
point1.SetData(dPos1)

# Cells
verts1 = vtk.vtkCellArray()
for i in range(dP1.GetNumberOfTuples()):
  verts1.InsertNextCell(1)
  verts1.InsertCellPoint(i)

# PolyData
polyData1 = vtk.vtkPolyData()
polyData1.SetPoints(point1)
polyData1.SetVerts(verts1)
polyData1.GetPointData().SetScalars(dP1)

#--------------------------------------------------------------------------------------
# DATA2
#--------------------------------------------------------------------------------------
# Pos data
filename ="Data2_Points.bin"    
f = open(filename, 'rb')
Npos2 = io.fread(f,1,'d')
print Npos2
CenterPos2 = io.fread(f,3,'d');
print CenterPos2

dPos2 = vtk.vtkDoubleArray()
dPos2.SetNumberOfComponents(3)
dPos2.SetNumberOfTuples(Npos2)
for i in range(Npos2):
    data = io.fread(f,3,'d')
    if i == 0:
        print data   
    dPos2.SetTuple3(i,data[0]*1000,data[1]*1000,data[2]*1000)
f.close

# Pressure Data
filename = "Data2_Scalars.bin"
f = open(filename,'rb')
dP2 = vtk.vtkDoubleArray()
dP2.SetNumberOfComponents(1)
dP2.SetNumberOfTuples(Npos2)
dP2.SetName('Pressure')

for i in range(Npos2):
    data = io.fread(f,1,'d')
    dP2.SetTuple1(i,data)
         
f.close

# Point
point2 = vtk.vtkPoints()
point2.SetNumberOfPoints(Npos2)
point2.SetData(dPos2)

# Cells
verts2 = vtk.vtkCellArray()
for i in range(dP2.GetNumberOfTuples()):
  verts2.InsertNextCell(1)
  verts2.InsertCellPoint(i)


# PolyData
polyData2 = vtk.vtkPolyData()
polyData2.SetPoints(point2)
polyData2.SetVerts(verts2)
polyData2.GetPointData().SetScalars(dP2)

#--------------------------------------------------------------------------------------
# DATA3
#--------------------------------------------------------------------------------------
# Pos data
filename ="Data3_Points.bin"    
f = open(filename, 'rb')
Npos3 = io.fread(f,1,'d')
print Npos3
CenterPos3 = io.fread(f,3,'d');
print CenterPos3

dPos3 = vtk.vtkDoubleArray()
dPos3.SetNumberOfComponents(3)
dPos3.SetNumberOfTuples(Npos3)
for i in range(Npos3):
    data = io.fread(f,3,'d')
    if i == 0:
        print data   
    dPos3.SetTuple3(i,data[0]*1000,data[1]*1000,data[2]*1000)
f.close

# Pressure Data
filename = "Data3_Scalars.bin"
f = open(filename,'rb')
dP3 = vtk.vtkDoubleArray()
dP3.SetNumberOfComponents(1)
dP3.SetNumberOfTuples(Npos3)
dP3.SetName('Pressure')

for i in range(Npos3):
    data = io.fread(f,1,'d')
    dP3.SetTuple1(i,data)
         
f.close

# Point
point3 = vtk.vtkPoints()
point3.SetNumberOfPoints(Npos3)
point3.SetData(dPos3)

# Cells
verts3 = vtk.vtkCellArray()
for i in range(dP3.GetNumberOfTuples()):
  verts3.InsertNextCell(1)
  verts3.InsertCellPoint(i)

# PolyData
polyData3 = vtk.vtkPolyData()
polyData3.SetPoints(point3)
polyData3.SetVerts(verts3)
polyData3.GetPointData().SetScalars(dP3)

print polyData3.GetNumberOfPoints()
      
#--------------------------------------------------------------------------------------
lut = vtk.vtkLookupTable()
lut.SetNumberOfColors(20)
lut.SetHueRange(.6667,0.0)
lut.Build()
#--------------------------------------------------------------------------------------
renWin1 = vtk.vtkRenderWindow()
ren1 = vtk.vtkRenderer() 
ren1.AutomaticLightCreationOn()
ren1.LightFollowCameraOn()
renWin1.AddRenderer(ren1)
iren1 = vtk.vtkRenderWindowInteractor()
renWin1.SetSize(800, 600)
iren1.SetRenderWindow(renWin1)
ren1.SetBackground(1,1,1)

#--------------------------------------------------------------------------------------
# append
#--------------------------------------------------------------------------------------
append = vtk.vtkAppendPolyData()
append.AddInput(polyData1)
append.AddInput(polyData2)
append.AddInput(polyData3)
append.Update()

cleanFilter = vtk.vtkCleanPolyData()
cleanFilter.SetInputConnection(append.GetOutputPort())
#cleanFilter.SetTolerance(0.02)
cleanFilter.Update()

print cleanFilter.GetOutput().GetNumberOfPoints() 


#--------------------------------------------------------------------------------------
# delaunay
#--------------------------------------------------------------------------------------
delaunay = vtk.vtkDelaunay3D()
delaunay.SetInput(cleanFilter.GetOutput())


#delaunay.SetTolerance(50)
delaunay.SetAlpha(80)

# shrink
shrink = vtk.vtkShrinkFilter()
shrink.SetInputConnection(delaunay.GetOutputPort())
shrink.SetShrinkFactor(0.6)

# mapper
mapper = vtk.vtkDataSetMapper()
mapper.SetInputConnection(shrink.GetOutputPort())
mapper.SetScalarRange(cleanFilter.GetOutputDataObject(0).GetPointData().GetArray('Pressure').GetRange())
mapper.SetScalarModeToUsePointData()
mapper.ScalarVisibilityOn()
mapper.SetLookupTable(lut)

# actor
actor = vtk.vtkActor()
actor.SetMapper(mapper)
#actor.GetProperty().SetColor(1,0,0)
actor.GetProperty().SetOpacity(0.05)

ren1.AddActor(actor)


#--------------------------------------------------------------------------------------
# Cutting
#--------------------------------------------------------------------------------------
plane = vtk.vtkPlane()
plCut = vtk.vtkCutter()
plCut.SetInputConnection(delaunay.GetOutputPort())
plCut.SetCutFunction(plane)

mapCut = vtk.vtkPolyDataMapper()
mapCut.SetInputConnection(plCut.GetOutputPort())

mapCut.SetLookupTable(lut)
#mapCut.SetScalarRange(cleanFilter.GetOutputDataObject(0).GetPointData().GetArray('Pressure').GetRange())
mapCut.SetScalarRange(-15,0)
actColmap = vtk.vtkActor()
actColmap.SetMapper(mapCut)

print cleanFilter.GetOutputDataObject(0).GetPointData().GetArray('Pressure').GetRange()

ren1.AddActor(actColmap)
#--------------------------------------------------------------------------------------

renWin1.Render()
iren1.Initialize()
renWin1.Render()
iren1.Start()
renWin1 = None




